<template>
  <div>
    <!-- <div class="container" v-if="loading">
      <div class="row">
        <div class="col-sm-12 pt-5">
          <div class="bubblingG">
            <span id="bubblingG_1"></span>
            <span id="bubblingG_2"></span>
            <span id="bubblingG_3"></span>
          </div>
        </div>
      </div>
    </div>-->

    <div class="container h-100" style="padding-top: 10rem">
      <div class="d-flex justify-content-center h-100">
        <div class="user_card">
          <div class="d-flex justify-content-center">
            <div class="brand_logo_container">
              <img :src="require('@/assets/utez.png')" alt="Logo Quiosco" class="brand_logo" />
            </div>
          </div>
          <div class="d-flex justify-content-center form_container">
            <form class="login" @submit="formLogin">
              <h5 class="text-center font-weight-light">SIGECI</h5>
              <!-- <span> -->
              <p class="text-center text-danger"></p>
              <!-- </span> -->
              <div class="input-group mb-1 form-group">
                <div class="input-group-append">
                  <span class="input-group-text">
                    <i class="material-icons">person</i>
                  </span>
                </div>
                <input
                  type="text"
                  v-model="$v.usuario.$model"
                  class="form-control input_user form__input"
                  placeholder="Usuario"
                  maxlength="18"
                  required
                />
              </div>
              <div
                class="error"
                v-if="!$v.usuario.minLength"
              >Introduce al menos {{$v.usuario.$params.minLength.min}} letras.</div>

              <div class="input-group mb-2">
                <div class="input-group-append">
                  <span class="input-group-text">
                    <i class="material-icons">vpn_key</i>
                  </span>
                </div>
                <input
                  type="password"
                  required
                  v-model="clave"
                  class="form-control input_pass"
                  placeholder="Contraseña"
                />
              </div>
              <span>{{notFound}}</span>
              <div
                class="error"
                v-if="!$v.clave.minLength"
              >Introduce al menos {{$v.clave.$params.minLength.min}} letras.</div>
              <div class="d-flex justify-content-center mt-3 login_container">
                <button
                  type="submit"
                  name="button"
                  class="btn submit"
                  :disabled="!$v.$anyDirty || $v.$anyError"
                >Iniciar sesión</button>
              </div>
            </form>
          </div>
          <!-- <span>{{sessionData}}</span> -->
          <h4 style="margin-top:30px;font-size:15px;text-align:center;">¿Eres Aspirante Nuevo? Registrate</h4>
          <div class="d-flex justify-content-center mt-3 login_container">
            <!-- Lanzador de modal -->
            <b-button
              id="show-btn"
              variant="outline-primary"
              @click="showModal('modal-registrar')"
            >Registrarse</b-button>
          </div>
          <!--Inicio modal-->
          <b-modal ref="modal-registrar" hide-footer size="lg" title="Nuevo Aspirante" >
            <div class="d-block text-justify">
              <b-form @submit="formSubmit">
                <h3 style="font-size:15px;color:grey;">Datos personales</h3>

                <div class="form-group">
                  <b-form-input
                    type="text"
                    placeholder="Nombre(s)"
                    v-model="nombre"
                    :state="validation"
                    max="20"
                    required
                  />
                  <b-form-invalid-feedback :state="validation">
                    Ingresa al menos 3 letras
                  </b-form-invalid-feedback>
                  
                </div> 

                <div class="row form-group">
                  <div class="col">
                    <b-form-input
                      type="text"                      
                      placeholder="Primer apellido"
                      v-model="primerApellido"
                      :state="lastName"  
                      required                   
                    />
                    <b-form-invalid-feedback :state="lastName">
                      Ingresa al menos 3 letras
                    </b-form-invalid-feedback>
                  </div>

                  <div class="col">
                    <b-form-input
                      type="text"
                      placeholder=" Segundo apellido"
                      v-model="segundoApellido"
                      :state="secondLastName"
                      required=""
                    />
                    <b-form-invalid-feedback :state="secondLastName">
                      Ingresa al menos 3 letras
                    </b-form-invalid-feedback>
                  </div>

                </div>

                <div class="form-group">
                  <b-form-input
                    type="email"
                    placeholder="Correo Electrónico"
                    v-model="correoPersonal"
                    required                    
                  />
                  <b-form-text>
                    Verifica el formato: ejemplo@ejemplo.com
                  </b-form-text>
                </div>

                <div class="form-group">
                  <b-form-input
                    type="text"
                    placeholder="CURP"
                    v-model="curp"
                    required
                    :state="Curp"
                    id="curpValidation"
                    @keyup="limitar()"
                  />
                  <b-form-invalid-feedback :state="Curp">
                      Tu CURP debe tener 18 dígitos
                  </b-form-invalid-feedback>
                  <small>
                    <a href="https://www.gob.mx/curp/" target="_blank">Consultar CURP</a>
                  </small>
                </div>

                <div class="row">
                  <div class="col">
                    <label for>Fecha de nacimiento</label>
                    <input type="date" class="form-control" v-model="fechaNac" required />
                  </div>
                  <!--Genero-->
                  <div class="col">
                    <label for>Genero</label>
                    <b-form-select class="form-control" v-model="sexo" required :state="genValid">
                      <option value="Femenino">Femenino</option>
                      <option value="Masculino">Masculino</option>
                      <option value="Otro">Otro</option>
                    </b-form-select>
                  </div>

                </div>

                <hr />

                <h3 style="font-size:15px;color:grey;">Domicilio</h3>

                <div class="form-group">
                  <b-form-input
                    v-model="nombreCalle"
                    type="text"
                    placeholder="Calle"
                    required
                    :state="nomCalle"
                  />
                  <b-form-invalid-feedback :state="nomCalle">
                    Debes ingresar al menos 5 letras.
                  </b-form-invalid-feedback>
                </div>

                <div class="row form-group">
                  <div class="col">
                    <b-form-input
                      type="text"
                      placeholder="Colonia"
                      v-model="colonia"
                      required
                      :state="colValid"
                    />
                    <b-form-invalid-feedback :state="colValid">
                      Debes ingresar al menos 5 letras.
                    </b-form-invalid-feedback>
                  </div>

                  <div class="col">
                    <b-form-input
                      type="number"
                      class="form-control"
                      placeholder="No. de casa"
                      v-model.number="numCasa"
                      :state="nCasa"
                      required
                    />
                    <b-form-invalid-feedback :state="nCasa">
                      Debes ingresar al 2 dígitos
                    </b-form-invalid-feedback>
                  </div>
                </div>

                <div class="form-group">
                  <b-form-input
                    type="text"
                    class="form-control"
                    placeholder="Municipio"
                    v-model="municipio"
                    required
                    :state="municipioValid"
                  />
                  <b-form-invalid-feedback :state="municipioValid">
                    Debes ingresar al menos 5 letras.
                  </b-form-invalid-feedback>
                </div>

                <div class="row form-group">
                  <div class="col form-group">
                    <b-form-input
                      type="text"
                      placeholder="Estado"
                      v-model="estado"
                      required
                      :state="estadoValid"
                    />
                    <b-form-invalid-feedback :state="estadoValid">
                      Debes ingresar al menos 5 letras.
                    </b-form-invalid-feedback>
                  </div>

                  <div class="col form-group">
                    <b-form-input
                      type="number"
                      placeholder="Código Postal"
                      v-model.number="coPostal"
                      required
                      :state="cpValid"
                    />
                    <b-form-invalid-feedback :state="cpValid">
                      Debes ingresar al menos 5 letras.
                    </b-form-invalid-feedback>
                  </div>
                </div>

                <div class="row form-group">

                  <div class="col">
                    <label for>Teléfono de casa</label>
                    <b-form-input                      
                      type="text"
                      placeholder="Solo 10 dígitos"
                      v-model="telCasa"
                      required
                      :state="telCasaValid"
                    />
                    <b-form-invalid-feedback :state="telCasaValid">
                      Debes ingresar 10 dígitos
                    </b-form-invalid-feedback>
                  </div>

                  <div class="col">
                    <label for>Teléfono movil</label>
                    <b-form-input                     
                      placeholder="Solo 10 dígitos"
                      v-model="telMovil"
                      required
                      :state="telMovilValid"
                    />
                    <b-form-invalid-feedback :state="telMovilValid">
                      Debes ingresar 10 dígitos
                    </b-form-invalid-feedback>
                  </div>

                </div>
                <div class="row form-group">
                  <div class="col">
                    <label for>Carrera</label>
                    <b-form-select v-model="carrera"  required :state="carreraValid">
                      <option
                        v-for="(carrera,index) in carreras"
                        :key="index"
                        :value="carrera.id"
                      >{{carrera.nombreCarrera}}</option>
                    </b-form-select>
                  </div>
                </div>
                <input type="submit" class="btn btn-success submit" value="Registrarse"/>
              </b-form>
            </div>
            <b-button
              class="mt-3"
              variant="outline-danger"
              block
              @click="hideModal('modal-registrar')"
            >Cerrar</b-button>
          </b-modal>
        </div>
      </div>
    </div>
  </div>
</template>

<style scoped>
.error {
  color: #d9585c;
  margin-top: 5px;
  display: block;
}

.submit {
  display: block;
  width: 100%;
  padding: 10px;
  border: 2px solid #019979;
  border-radius: 4px;
  background: #019979;
  color: white;
  transition: 0.3s;
}
.submit:hover {
  color: white;
  border-color: white;
}
.submit:disabled,
.submit[disabled] {
  border: 2px solid #019979;
  background-color: #019979;
  color: #fff;
}
.user_card {
  height: 400px;
  width: 350px;
  margin-top: auto;
  margin-bottom: auto;
  background: #fbfbfb;
  position: relative;
  display: flex;
  justify-content: center;
  flex-direction: column;
  padding: 10px;
  box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
  -webkit-box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2),
    0 6px 20px 0 rgba(0, 0, 0, 0.19);
  -moz-box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2),
    0 6px 20px 0 rgba(0, 0, 0, 0.19);
  border-radius: 5px;
}
.brand_logo_container {
  position: absolute;
  height: 170px;
  width: 170px;
  top: -75px;
  border-radius: 50%;
  background: #fff;
  padding: 10px;
  text-align: center;
}
.brand_logo {
  height: 150px;
  width: 150px;
  border-radius: 50%;
  border: 3px solid #019979;
}
.form_container {
  margin-top: 75px;
}
.login_btn {
  width: 100%;
  background: #019979 !important;
  color: white !important;
}
.login_btn:focus {
  box-shadow: none !important;
  outline: 0px !important;
}
.login_container {
  padding: 0 2rem;
}
.input-group-text {
  background: #019979 !important;
  color: white !important;
  border: 0 !important;
  border-radius: 0.25rem 0 0 0.25rem !important;
}
.input_user,
.input_pass:focus {
  box-shadow: none !important;
  outline: 0px !important;
}
.custom-checkbox .custom-control-input:checked ~ .custom-control-label::before {
  background-color: #019979 !important;
}

/* Loader */
.bubblingG {
  width: 90px;
  height: 56px;
  position: fixed;
  z-index: 999;
  overflow: visible;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
  margin: auto;
}

.bubblingG span {
  display: inline-block;
  vertical-align: middle;
  width: 11px;
  height: 11px;
  margin: 28px auto;
  background: rgba(1, 153, 121, 0.9);
  border-radius: 56px;
  -o-border-radius: 56px;
  -ms-border-radius: 56px;
  -webkit-border-radius: 56px;
  -moz-border-radius: 56px;
  animation: bubblingG 0.715s infinite alternate;
  -o-animation: bubblingG 0.715s infinite alternate;
  -ms-animation: bubblingG 0.715s infinite alternate;
  -webkit-animation: bubblingG 0.715s infinite alternate;
  -moz-animation: bubblingG 0.715s infinite alternate;
}

#bubblingG_1 {
  animation-delay: 0s;
  -o-animation-delay: 0s;
  -ms-animation-delay: 0s;
  -webkit-animation-delay: 0s;
  -moz-animation-delay: 0s;
}

#bubblingG_2 {
  animation-delay: 0.2095s;
  -o-animation-delay: 0.2095s;
  -ms-animation-delay: 0.2095s;
  -webkit-animation-delay: 0.2095s;
  -moz-animation-delay: 0.2095s;
}

#bubblingG_3 {
  animation-delay: 0.429s;
  -o-animation-delay: 0.429s;
  -ms-animation-delay: 0.429s;
  -webkit-animation-delay: 0.429s;
  -moz-animation-delay: 0.429s;
}
@keyframes bubblingG {
  0% {
    width: 11px;
    height: 11px;
    background-color: rgb(1, 153, 121);
    transform: translateY(0);
  }

  100% {
    width: 27px;
    height: 27px;
    background-color: rgb(255, 255, 255);
    transform: translateY(-24px);
  }
}

@-o-keyframes bubblingG {
  0% {
    width: 11px;
    height: 11px;
    background-color: rgb(1, 153, 121);
    -o-transform: translateY(0);
  }

  100% {
    width: 27px;
    height: 27px;
    background-color: rgb(255, 255, 255);
    -o-transform: translateY(-24px);
  }
}

@-ms-keyframes bubblingG {
  0% {
    width: 11px;
    height: 11px;
    background-color: rgb(1, 153, 121);
    -ms-transform: translateY(0);
  }

  100% {
    width: 27px;
    height: 27px;
    background-color: rgb(255, 255, 255);
    -ms-transform: translateY(-24px);
  }
}

@-webkit-keyframes bubblingG {
  0% {
    width: 11px;
    height: 11px;
    background-color: rgb(1, 153, 121);
    -webkit-transform: translateY(0);
  }

  100% {
    width: 27px;
    height: 27px;
    background-color: rgb(255, 255, 255);
    -webkit-transform: translateY(-24px);
  }
}

@-moz-keyframes bubblingG {
  0% {
    width: 11px;
    height: 11px;
    background-color: rgb(1, 153, 121);
    -moz-transform: translateY(0);
  }

  100% {
    width: 27px;
    height: 27px;
    background-color: rgb(255, 255, 255);
    -moz-transform: translateY(-24px);
  }
}
</style>

<script>
import { required, minLength } from "vuelidate/lib/validators";
import axios from "axios";
import { server } from "../../store";
import { functions } from "../../functionsGolbals";

import Vue from "vue";
import Vuelidate from "vuelidate";
Vue.use(Vuelidate);

export default {
  mixins: [functions],
  data() {
    return {
      notFound:null,
      carreras: [],
      carrera: '',
      output: null,
      sessionData: null,
      nombre:'',
      primerApellido: '',
      segundoApellido: '',
      curp: '',
      fechaNac: null,
      nombreCalle: '',
      numCasa: '',
      colonia: '',
      estado: '',
      coPostal: '',
      municipio: '',
      telCasa: '',
      telMovil: '',
      correoPersonal: '',
      sexo: '',
      usuario: null,
      clave: null
    };
  },  
  computed:{
    validation() {
        if(this.nombre.length == 0) return null;
        if(this.nombre.length > 2) return true;
        else return false;
      },
    lastName(){
      if(this.primerApellido.length == 0 ) return null;
      if(this.primerApellido.length > 2 ) return true;
      else return false;    
    },
    secondLastName(){
      if(this.segundoApellido.length == 0 ) return null;
      if(this.segundoApellido.length > 2) return true;
      else return false; 
    },
    Curp(){
      if(this.curp.length == 18) return true;
      if(this.curp.length == 0) return null;
      else return false;
    },
    colValid(){
      if(this.colonia.length == 0 ) return null;
      if(this.colonia.length > 4) return true;
      else return false;
    },
    nomCalle(){
      if(this.nombreCalle.length == 0) return null;
      if(this.nombreCalle.length > 4 ) return true;
      else return false;
    },
    nCasa(){
      if(this.numCasa.length == 0 ) return null;
      if(this.numCasa.length > 1) return false;
      else return true;

    },
    municipioValid(){
      if(this.municipio.length == 0) return null;
      if(this.municipio.length > 4)return true;
      else return false;
    },
    estadoValid(){
      if(this.estado.length == 0 ) return null;
      if(this.estado.length > 4) return true;
      else return false;
    },
    cpValid(){
      if(this.coPostal.length == 0) return null;
      if(this.coPostal.length > 1 ) return false;
      else return true;
      
    },
    telCasaValid(){
      if(this.telCasa.length == 0 ) return null;
      if(this.telCasa.length > 1 && this.telCasa.length == 10) return true;
      else return false;
    },
    telMovilValid(){
      if(this.telMovil.length == 0)return null;
      if(this.telMovil.length > 1 && this.telMovil.length == 10) return true;
      else return false;
    },
    genValid(){
      if(this.sexo == '') return null;
      else return true;
    },
    carreraValid(){
      if(this.carrera == '')return null;
      else return true;
    }

    
  },
  mounted() {
    this.obtenerCarreras();
    localStorage.clear();
  },
  methods: {
    formLogin(e) {
      e.preventDefault();
      let objeto = this;
      axios
        .post(`${server.baseURL}/api/usuario/login`, {
          usuario: {
            usuario: this.usuario,
            clave: this.clave
          }
        })
        .then(function(response) {
          objeto.sessionData = response.data;
          // alert(objeto.sessionData.response.error);
          if(objeto.sessionData.response.error == false){
            objeto.$store.state.datos = objeto.sessionData;
            const parsed = JSON.stringify(objeto.sessionData.response.response[0]);
            localStorage.setItem('usuario', parsed);
            objeto.$store.state.usuario = JSON.parse(localStorage.getItem('usuario'));
            objeto.$router.push("/home");
          }else{
            objeto.alertError(objeto.sessionData.response.response);
            objeto.usuario=null;
            objeto.clave=null;
          }
          // alert( "username = " + localStorage.getItem('usuario'));
        })
        .catch(function(error) {
          objeto.output = error;
        });
    },
    obtenerCarreras() {
      axios
        .get(`${server.baseURL}/api/carrera/lista`)
        .then(data => (this.carreras = data.data));
    },
    formSubmit(e) {
      e.preventDefault();
      let currentObj = this;
      axios
        .post(`${server.baseURL}/api/aspirantse/registro`, {
          aspirante: {
            nombre: this.nombre,
            primerApellido: this.primerApellido,
            segundoApellido: this.segundoApellido,
            curp: this.curp,
            fechaNacimiento: this.fechaNac,
            nombreCalle: this.nombreCalle,
            numeroCasa: this.numCasa,
            colonia: this.colonia,
            estado: this.estado,
            codPostal: this.coPostal,
            municipio: this.municipio,
            telCasa: this.telCasa,
            telMovil: this.telMovil,
            correoPersonal: this.correoPersonal,
            sexo: this.sexo,
            carreraID: this.carrera
          }
        })
        .then(function(response) {
          currentObj.output = response.data;
          currentObj.hideModal("modal-registrar");
          currentObj.alertSuccess(currentObj.output.response.message);
        })
        .catch(function(error) {
          currentObj.output = error;
          currentObj.alertError(currentObj.output.response.message);
         
        });
    },
    limitar(){         
      if(this.curp.length >= 18){
        this.curp=this.curp.substring(0,18);        
      }
     
    }
  },
  validations: {
    usuario: {
      required,
      minLength: minLength(12)
    },
    clave: {
      required,
      minLength: minLength(3)
    }
  }
};
</script>
